% Generazione di una sinusoide 
clear x; 
A=1; 
fo=1000; 
fs=6000; 
sigma2=0.5; 
lun=50000; 
 
for i=1:lun 
 x(i)=A*cos(2*pi*fo*i/fs)+randn*sqrt(sigma2); 
end 

% Disegno i primi K campioni della sinusoide
K = 1000;
xt = x(1:K);
Tc = 1/fs;
plot([0:Tc:(K-1)*Tc],xt); title('Sinusoide + AWGN'); xlabel('t[s]');

%Periodogramma 128
N = 128;
I = (abs(fft(x(1:N))).^2)./(N*fs);
f = [0:fs/N:(N-1)*fs/N];
figure; plot(f,I); title('Periodogramma con 128 punti'); xlabel('f[Hz]');

%Periodogramma 1024
N = 1024;
I = (abs(fft(x(1:N))).^2)./(N*fs);
f = [0:fs/N:(N-1)*fs/N];
figure; plot(f,I); title('Periodogramma con 1024 punti'); xlabel('f[Hz]');

%Periodogramma 2^14
N = 2^14;
I = (abs(fft(x(1:N))).^2)./(N*fs);
f = [0:fs/N:(N-1)*fs/N];
figure; plot(f,I); title('Periodogramma con 2^{14} punti'); xlabel('f[Hz]');