%carico il file
[x,fs,nbits,opts] = wavread('pianoforte.wav');
 
%calcolo l'intervallo temporale di campionamento
Tc = 1/fs;
%creo l'asse temporale
t = [0:Tc:Tc*(length(x)-1)];
%disegno il segnale
plot(t,x); title('Pianoforte.wav'); xlabel('t[s]'); ylabel('x(t)');
 
%ascolto il segnale
sound(x,fs,nbits);
 
%estraggo le tre note e le grafico
x1 = x(1:50e3);
x2 = x(100e3:200e3);
x3 = x(200e3:290e3);
t1 = [0:Tc:Tc*(length(x1)-1)];
t2 = [0:Tc:Tc*(length(x2)-1)];
t3 = [0:Tc:Tc*(length(x3)-1)];
figure; 
subplot(311); plot(t1,x1); title('Prima nota'); xlabel('t[s]');
subplot(312); plot(t2,x2); title('Seconda nota'); xlabel('t[s]');
subplot(313); plot(t3,x3); title('Terza nota'); xlabel('t[s]');
 
%grafico lo spettro delle 3 note
N = length(x1);
I = (abs(fft(x1)).^2)./(N*fs);
f = [0:fs/N:2000];
figure; subplot(311); plot(f,I(1:length(f))); title('Spettro della prima nota'); xlabel('f[Hz]');
N = length(x2);
I = (abs(fft(x2)).^2)./(N*fs);
f = [0:fs/N:2000];
subplot(312); plot(f,I(1:length(f))); title('Spettro della seconda nota'); xlabel('f[Hz]');
N = length(x3);
I = (abs(fft(x3)).^2)./(N*fs);
f = [0:fs/N:2000];
subplot(313); plot(f,I(1:length(f))); title('Spettro della terza nota'); xlabel('f[Hz]');
