%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ESERCIZIO 4
%
% Il programma richiede in input le veriabili T,N e fmax.
% T: periodo di ripetizione di x(t)
% N: numero dei campioni
% fmax: massima frequenza da visualizzare
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear     % pulisce il workspace
close all % chiude tutte le figure

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
% LETTURA PARAMETRI 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tau = input('Parametro dell''impulso [sec]= ');
T = input('Periodo di ripetizione nel tempo [sec]= ');
N = input('Numero di campioni [meglio se 2^k] = ');
fmax = input('Max freq. dello spettro visualizz. [Hz]= ');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PASSI CAMPIONAMENTO 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dt = T/N;
df = 1/T;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARAMETRI DEL FILTRO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
F = N/T;
ft = 1/tau;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CAMPION. DELLA RIPETIZIONE PER. DI x(t) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:N, 
    tempo(i)=(i-1)*dt;
    x(i)=segnale(tempo(i),tau);
    xr(i)=segnale(tempo(i),tau)+segnale(tempo(i)-T,tau)+segnale(tempo(i)-2*T,tau)+segnale(tempo(i)+T,tau)+segnale(tempo(i)+2*T,tau); 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CALCOLO SPETTRO MEDIANTE FFT 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Xr=dt*fft(xr);
freq=[0:df:(N-1)*df];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CALCOLO LA RIPETIZIONE DEL FILTRO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:N, 
    H(i) = filtro(freq(i),ft);
    Hr(i) = filtro(freq(i),ft)+filtro(freq(i)-F,ft)+filtro(freq(i)-(2*F),ft)+filtro(freq(i)+F,ft)+filtro(freq(i)+(2*F),ft); 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CALCOLO LO SPETTRO A VALLE DEL FILTRO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Yr = Hr.*Xr;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PORZIONE DI SPETTRO da 0-fmax
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
npunti = min(round(fmax*T),N);
freq = freq(1:npunti);
Xrs = Xr(1:npunti);
Hrs = Hr(1:npunti);
Yrs = Yr(1:npunti);
figure;
subplot(311),plot(freq,abs(Xrs)),xlabel('freq. [Hz]'),ylabel('|X(f)|');
subplot(312),plot(freq,abs(Hrs)),xlabel('freq. [Hz]'),ylabel('|H(f)|');
subplot(313),plot(freq,abs(Yrs)),xlabel('freq. [Hz]'),ylabel('|Y(f)|');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ANTITRASFORMO E GRAFICO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y = (1/dt).*ifft(Yr);
t = [0:dt:dt*(N-1)];
figure;plot(t(1:1000),x(1:1000),'red',t(1:1000),y(1:1000),'blue');xlabel('t[s]');title('Confronto fra il segnale prima del filtro e dopo il filtro');
