% Generazione segnale PAM 
%clear all; 
fs=16000; 
rs=200;     % symbol rate = simboli al secondo 
nbit=10000; % lunghezza in bit del segnale 
 
sc=fs/rs;   % fattore di sovracampionamento = campioni per simbolo 
 
%for i=1:sc y(i)=1; end 
%x=y; 
%for j=1:nbit  
%    y=y*sign(rand-0.5); 
%    x=[x y]; 
%end

%salvo il segnale
%save pam.dat -ascii x

%carico il segnale
x = load('pam.dat');

% Disegno i primi K campioni del PAM
K = 1000;
xt = x(1:K);
Tc = 1/fs;
plot([0:Tc:(K-1)*Tc],xt); title('PAM'); xlabel('t[s]');

%Periodogramma 1024
N = 1024;
I = (abs(fft(x(1:N))).^2)./(N*fs);
f = [0:fs/N:(N-1)*fs/N];
figure; plot(f,I); title('Periodogramma con 1024 punti'); xlabel('f[Hz]');

%Confronto con lo spettro teorico
Steo=(1/rs).*((sinc(f./rs)).^2);
figure; plot(f,Steo,'red',f,I,'blue'); title('Confronto con lo spettro di potenza teorico'); xlabel('f[Hz]');

%Periodogramma 2^14
N = 2^14;
I = (abs(fft(x(1:N))).^2)./(N*fs);
f = [0:fs/N:(N-1)*fs/N];
figure; plot(f,I); title('Periodogramma con 2^{14} punti'); xlabel('f[Hz]');

%Confronto con lo spettro teorico
Steo=(1/rs).*((sinc(f./rs)).^2);
figure; plot(f,Steo,'red',f,I,'blue'); title('Confronto con lo spettro di potenza teorico'); xlabel('f[Hz]');