% Generazione segnale PAM 
clear all; 
fs=16000; 
rs=200;     % symbol rate = simboli al secondo 
nbit=10000; % lunghezza in bit del segnale 
 
sc=fs/rs;   % fattore di sovracampionamento = campioni per simbolo 
 
%for i=1:sc y(i)=1; end 
%x=y; 
%for j=1:nbit  
%    y=y*sign(rand-0.5); 
%    x=[x y]; 
%end

%salvo il segnale
%save pam.dat -ascii x

%carico il segnale
x = load('pam.dat');

%Periodogramma 2^16
N = 2^16;
I = (abs(fft(x(1:N))).^2)./(N*fs);
f = [0:fs/N:(N-1)*fs/N];
%figure; plot(f,I); title('Periodogramma con 2^{16} punti'); xlabel('f[Hz]');

%Confronto con lo spettro teorico
Steo=(1/rs).*((sinc(f./rs)).^2);
figure; plot(f,Steo,'red',f,I,'blue'); title('Periodogramma con 2^{16} punti'); xlabel('f[Hz]');

%Media dei periodogrammi 2^14 con 6 blocchi
N = 2^14;
L = 6;
I = zeros(1,N);
for i = 1:L
    xt = x(((i-1)*N)+1 : (i*N));
    I = I + ((abs(fft(xt)).^2)./(N*fs));
end
Iavg = I ./ L;

f = [0:fs/N:(N-1)*fs/N];
%figure;plot(f,Iavg); title('Periodogramma con 2^{14} punti e L = 6'); xlabel('f[Hz]');

%Confronto con lo spettro teorico
Steo=(1/rs).*((sinc(f./rs)).^2);
figure; plot(f,Steo,'red',f,Iavg,'blue'); title('Periodogramma con 2^{14} punti e L = 6'); xlabel('f[Hz]');

%Media dei periodogrammi 2^10 con 90 blocchi
N = 2^10;
L = 90;
I = zeros(1,N);
for i = 1:L
    xt = x(((i-1)*N)+1 : (i*N));
    I = I + ((abs(fft(xt)).^2)./(N*fs));
end
Iavg = I ./ L;

f = [0:fs/N:(N-1)*fs/N];
%figure; plot(f,Iavg); title('Periodogramma con 2^{10} punti e L = 90'); xlabel('f[Hz]');

%Confronto con lo spettro teorico
Steo=(1/rs).*((sinc(f./rs)).^2);
figure; plot(f,Steo,'red',f,Iavg,'blue'); title('Periodogramma con 2^{10} punti e L = 90'); xlabel('f[Hz]');

