close all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%RETTANGOLARE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N=1280;
finestra=boxcar(N)';   % inserire le diverse tipologie di  finestre 
finestra=[finestra zeros(1,2^14)]; 
    				% aumentando T con gli zeri riduciamo 
    				% df per avere una migliore risoluzione in freq.
T=length(finestra);
dt=1;
df=1/T;
spettro1=dt*fft(finestra);
spettro1 = 20*log10(abs(spettro1));
freq=[0:df:(T-1)*df]; % poiche dt=1 ? allora le freq. sono normalizzate
stem(finestra(1:1500), 'y'); title('Finetra Boxcar'); xlabel('Campioni'); ylabel('Ampiezza');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%BARTLETT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
finestra=bartlett(N)';   % inserire le diverse tipologie di  finestre 
finestra=[finestra zeros(1,2^14)]; 
    				% aumentando T con gli zeri riduciamo 
    				% df per avere una migliore risoluzione in freq.
spettro2=dt*fft(finestra);
spettro2 = 20*log10(abs(spettro2));
figure;
stem(finestra(1:1500), 'm'); title('Finetra Bartlett'); xlabel('Campioni'); ylabel('Ampiezza');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%HANNING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
finestra=hanning(N)';   % inserire le diverse tipologie di  finestre 
finestra=[finestra zeros(1,2^14)]; 
    				% aumentando T con gli zeri riduciamo 
    				% df per avere una migliore risoluzione in freq.
spettro3=dt*fft(finestra);
spettro3 = 20*log10(abs(spettro3));
figure;
stem(finestra(1:1500), 'c'); title('Finetra Hanning'); xlabel('Campioni'); ylabel('Ampiezza');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%HAMMING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
finestra=hamming(N)';   % inserire le diverse tipologie di  finestre 
finestra=[finestra zeros(1,2^14)]; 
    				% aumentando T con gli zeri riduciamo 
    				% df per avere una migliore risoluzione in freq.
spettro4=dt*fft(finestra);
spettro4 = 20*log10(abs(spettro4));
figure;
stem(finestra(1:1500), 'r'); title('Finetra Hamming'); xlabel('Campioni'); ylabel('Ampiezza');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%BLACKMAN
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
finestra=blackman(N)';   % inserire le diverse tipologie di  finestre 
finestra=[finestra zeros(1,2^14)]; 
    				% aumentando T con gli zeri riduciamo 
    				% df per avere una migliore risoluzione in freq.
spettro5=dt*fft(finestra);
spettro5 = 20*log10(abs(spettro5));
figure;
stem(finestra(1:1500), 'g'); title('Finetra Blackman'); xlabel('Campioni'); ylabel('Ampiezza');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%KAISER
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
finestra=kaiser(N, 5)';   % inserire le diverse tipologie di  finestre 
finestra=[finestra zeros(1,2^14)]; 
    				% aumentando T con gli zeri riduciamo 
    				% df per avere una migliore risoluzione in freq.
spettro6=dt*fft(finestra);
spettro6 = 20*log10(abs(spettro6));
figure;
stem(finestra(1:1500), 'b'); title('Finetra Kaiser'); xlabel('Campioni'); ylabel('Ampiezza');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SPETTRI DELLE FINESTRE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure; plot(freq, spettro1, 'y', freq, spettro2, 'm', freq, spettro3, ...
    'c', freq, spettro4, 'r', freq, spettro5, 'g', freq, spettro6, 'b');
title('Spettro delle finestre');
xlabel('Frequenza [Hz]');
ylabel('Ampiezza [dB]');