fs = 48000;   % freq. camp = 1/T
ft = 2500;    % freq. taglio
f = [0:1:10e3];
N = 51;       % numero prese
a = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRO 51 PRESE RETTANGOLARE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = fir1(N-1, ft/(fs/2), boxcar(N));
H1 = 20*log10(abs(freqz(b, a, f, fs)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRO 51 PRESE BARTLETT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = fir1(N-1, ft/(fs/2), bartlett(N));
H2 = 20*log10(abs(freqz(b, a, f, fs)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRO 51 PRESE HANNING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = fir1(N-1, ft/(fs/2), hanning(N));
H3 = 20*log10(abs(freqz(b, a, f, fs)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRO 51 PRESE HAMMING
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = fir1(N-1, ft/(fs/2), hamming(N));
H4 = 20*log10(abs(freqz(b, a, f, fs)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRO 51 PRESE BLACKMAN
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = fir1(N-1, ft/(fs/2), blackman(N));
H5 = 20*log10(abs(freqz(b, a, f, fs)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FILTRO 51 PRESE KAISER
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = fir1(N-1, ft/(fs/2), kaiser(N,5));
H6 = 20*log10(abs(freqz(b, a, f, fs)));

plot(f, H1, 'y', f, H2, 'm', f, H3, 'c', f, H4, 'r', f, H5, 'g', f, H6, ...
    'b'); xlabel('Frequenza [Hz]'); title('Ampiezza FdT'); ylabel('|H| [dB]');
