clear, close all

fs = 48000; 	% freq. camp = 1/T
ft = 1000; 	   	% freq. taglio
df = 2000;   	% banda di transizione
d1 = 0.171;    	% massimo ripple
d2 = 0.031;		% guadagno in banda attenuata
Nemp = ceil((2/3)*log10(1/(10*d1*d2))*fs/df);   		% numero prese

N = 68;

freqmask = [0 ft/(fs/2) (ft+df)/(fs/2) 1];
amplmask = [1 1 d2 d2];
weights = [d1 d1/d2];

b = remez(N-1,freqmask,amplmask,weights);

fmax = 15000;    % max freq. da visualizzare
punti = 300;     % numero punti del grafico
freq = 0:fmax/punti:fmax;
fdt = freqz(b,1,freq,fs);

%Grafici
subplot(211);plot(freq, 20*log10(abs(fdt))); title('N = 68'); xlabel('f [Hz]'); ylabel('|H| [dB]');grid; 
subplot(212);plot(freq, angle(fdt)); xlabel('f [Hz]'); ylabel('arg(H)'); grid;
