clear, close all

fs = 20000; 	% freq. camp = 1/T
f1 = 100; 	   	% freq. taglio
f2 = 200;
f3 = 4000;
f4 = 4100;
Rp = 1.5;
d1 = (10^(Rp/20)-1)/(10^(Rp/20)+1);    	% massimo ripple
A = 20;
d2 = 10^(-A/20);

N = 250;

%Definizione maschera
freqmask = [0 f1/(fs/2) f2/(fs/2) f3/(fs/2) (f4)/(fs/2) 1];
amplmask = [d2 d2 1 1 d2 d2];
weights = [d1/d2 d1 d1/d2];

b = remez(N-1,freqmask,amplmask,weights);

fmax = 7000;    % max freq. da visualizzare
punti = 300;     % numero punti del grafico
freq = 0:fmax/punti:fmax;
fdt = freqz(b,1,freq,fs);

%Grafici
subplot(211);plot(freq, 20*log10(abs(fdt))); title('N = 250'); xlabel('f [Hz]'); ylabel('|H| [dB]');grid; 
subplot(212);plot(freq, angle(fdt)); xlabel('f [Hz]'); ylabel('arg(H)'); grid;
